#if !defined(lcd_H)
#define lcd_H

#include "typedefs.h"

#define DLY	\
asm ("NOP"); \
asm ("NOP");

// control line pins
#define	IM0		1
#define	IM1		2
#define	IM2		4
#define	RES		8
#define	CS		0x10
#define	CD		0x20
#define	WR		0x40
#define	RD		0x80

#define OUT_LO	PORTE
#define LCD_DATA PORTE
#define IN_LO	PINE
#define DDR_LO	DDRE

#define OUT_HI	PORTA
#define IN_HI	PINA
#define DDR_HI	DDRA

#define CTRL	PORTC
#define DDR_CT	DDRC

#define MODE16	1 //IM1
#define MODE8	3 //(IM1 + IM0)

#define OUTS	0xFF
#define INS		0

// macros for control lines
#define CLR_CD 		CTRL &= ~CD;
#define SET_CD 		CTRL |= CD;

#define CLR_CS 		CTRL &= ~CS;
#define SET_CS 		CTRL |= CS;

#define CLR_RESET 	CTRL &= ~RES;
#define SET_RESET 	CTRL |= RES;

#define CLR_WR 		CTRL &= ~WR;
#define SET_WR 		CTRL |= WR;

#define CLR_RD 		CTRL &= ~RD;
#define SET_RD 		CTRL |= RD;

// color definitions
// maximum values for R, G, B are 31, 63, 31 (5b, 6b, 5b)
// 16 bit color RRRR RGGG GGGB BBBB
#define RGB(r,g,b)	(uint16)(((b & 0x1F) * 2048) | ((g & 0x3F) * 32) | (r & 0x1F))

#define	BLACK	0x0000
#define	BLUE	0xF800 //RGB(0,0,31) //0x001F
#define	RED		0x001F //RGB(31,0,0) //0xF800
#define	GREEN	0x07E0 //RGB(0,63,0) //0x07E0
#define CYAN	0xFFE0 //RGB(0,63,31) //0x07FF
#define MAGENTA	0xF81F //RGB(31,0,31) //0xF81F
#define YELLOW	0x07FF //RGB(31,63,0) //0xFFE0
#define WHITE	0xFFFF //RGB(31,63,31) //0xFFFF


void delay(uint16 x);
void write_command(uint8 command);
void write_data(uint8 data_h, uint8 data_l);
void initialize_display(void);
void display_colors(void);
void display_bg(uint8 x, uint8 y, uint8 pWidth, uint8 pHeight, const PBYTE *pPat);
void color_block(uint8 x, uint8 y, uint8 w, uint8 h, uint8 rrrr_rggg, uint8 gggb_bbbb);

#endif
